//+------------------------------------------------------------------+
//|                                         Heiken Ashi Smoothed.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
#include <Pop.mqh>

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 OrangeRed
#property indicator_minimum -1
#property indicator_maximum +1

//---- parameters
extern double  WeightDM=2.5;
extern double  WeightDI=2.0;
extern double  WeightDX=1.0;
extern double  WeightOut=2.0;//1.0
extern string  MA="===== Moving Average of Chimp2 =====";
extern int     MA.Period               = 10;
extern string  MA.Method.Description   = "0=Simple/1=Expon/2=Smooth/3=Weighted";
extern int     MA.Method               = 1;
extern bool    Use.Alert.On.Cross      = True;
extern bool    Use.Pop.MSN.Alerts      = True;
extern bool    Draw.Arrows.On.Chart    = True;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];

//----
int ExtCountedBars=0;
datetime alertTag;
string signal;
string lastsignal;
bool bSkipInitial=True;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   IndicatorBuffers(7);

   SetIndexStyle(0,DRAW_LINE, 0, 2, DodgerBlue);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE, 0, 2, OrangeRed);
   SetIndexBuffer(1, ExtMapBuffer2);
//----
   SetIndexDrawBegin(0,4);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel (0,"Chimp2 Value"); 
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel (1,"MA Value"); 

   SetIndexBuffer(2,ExtMapBuffer3); // ExtMapBuffer3
   SetIndexBuffer(3,ExtMapBuffer4); // ExtMapBuffer4
   SetIndexBuffer(4,ExtMapBuffer5); // ExtMapBuffer5
   SetIndexBuffer(5,ExtMapBuffer6); // ExtMapBuffer6
   SetIndexBuffer(6,ExtMapBuffer7); // ExtMapBuffer7

   SetLevelStyle(STYLE_DOT,1,White);  
   SetLevelValue(0,0.85);
   SetLevelValue(1,0.04);
   SetLevelValue(2,-0.04);
   SetLevelValue(3,-0.85);  

   if (WeightDM <1.0)WeightDM =1.0;
   if (WeightDI <1.0)WeightDI =1.0;
   if (WeightDX <1.0)WeightDX =1.0;
   if (WeightOut<1.0)WeightOut=1.0;

   bSkipInitial = True;
 
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{  for(int i=0;i<ObjectsTotal();i++)
   {  ObjectsDeleteAll(0,OBJ_ARROW);
   }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double TR,DI_Diff, DI_Sum, DI_Factor, VI; 

   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int i=Bars-ExtCountedBars-1;
   while(i>=0)
     {

      ExtMapBuffer3[i]=0;
      ExtMapBuffer4[i]=0;
      if(Close[i]>Close[i+1])ExtMapBuffer3[i]=Close[i]-Close[i+1];
      else ExtMapBuffer4[i]=Close[i+1]-Close[i];
      ExtMapBuffer3[i]*=ExtMapBuffer3[i];
      ExtMapBuffer3[i]/=Volume[i];
      ExtMapBuffer4[i]*=ExtMapBuffer4[i];
      ExtMapBuffer4[i]/=Volume[i];    
      ExtMapBuffer3[i]=((WeightDM-1)*ExtMapBuffer3[i+1] + ExtMapBuffer3[i])/WeightDM;//ema.
      ExtMapBuffer4[i]=((WeightDM-1)*ExtMapBuffer4[i+1] + ExtMapBuffer4[i])/WeightDM;//ema.
   
      TR=ExtMapBuffer3[i]+ExtMapBuffer4[i];
      if (TR>0) 
      {  ExtMapBuffer5[i]=ExtMapBuffer3[i]/TR; 
         ExtMapBuffer6[i]=ExtMapBuffer4[i]/TR;
      }//Avoid division by zero. Minimum step size is one unnormalized price pip.
      else 
      {  ExtMapBuffer5[i]=0; 
         ExtMapBuffer6[i]=0;
      }
   
      ExtMapBuffer5[i]=((WeightDI-1)*ExtMapBuffer5[i+1] + ExtMapBuffer5[i])/WeightDI;//ema.
      ExtMapBuffer6[i]=((WeightDI-1)*ExtMapBuffer6[i+1] + ExtMapBuffer6[i])/WeightDI;//ema.
      DI_Diff=ExtMapBuffer5[i]-ExtMapBuffer6[i];  
      if (DI_Diff<0) DI_Diff= -DI_Diff;//Only positive momentum signals are used.
      DI_Sum=ExtMapBuffer5[i]+ExtMapBuffer6[i];
      DI_Factor=0;//Zero case, DI_Diff will also be zero when DI_Sum is zero.
      if (DI_Sum>0) ExtMapBuffer7[i]=DI_Diff/DI_Sum;//Factional, near zero when ExtMapBuffer3==ExtMapBuffer4 (horizonal), near 1 for laddering.
      else ExtMapBuffer1[i]=0;
   
      ExtMapBuffer7[i]=((WeightDX-1)*ExtMapBuffer7[i+1] + ExtMapBuffer7[i])/WeightDX;
                        
      if(ExtMapBuffer6[i]>ExtMapBuffer5[i])ExtMapBuffer7[i]=-ExtMapBuffer7[i];//Liable to cause sudden directional change if large WeightDX or WeightOut numbers used.
      ExtMapBuffer1[i]=((WeightOut-1)*ExtMapBuffer1[i+1]+ExtMapBuffer7[i])/WeightOut;

 	   i--;
     }

   for(i=0; i<Bars; i++) ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer1,Bars,MA.Period,0,MA.Method,i);
   

   if ((ExtMapBuffer2[1]>ExtMapBuffer1[1]) && (ExtMapBuffer2[2]<ExtMapBuffer1[2])) 
   {  if (Use.Alert.On.Cross)
      {  signal="Short";
         if ((lastsignal != signal) && (alertTag!=Time[0]))
         {  
            Alert ("Chimp and MA of Chimp crossinng SHORT ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
            if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" Chimp and MA Crossing SHORT "), "C:\\");
            alertTag = Time[0];
            lastsignal=signal;
         }
      }
   }
   else 
   {  if ((ExtMapBuffer2[1]<ExtMapBuffer1[1]) && (ExtMapBuffer2[2]>ExtMapBuffer1[2])) 
      {  
         if (Use.Alert.On.Cross)
         {  
            signal="Long";
            if ((lastsignal != signal) && (alertTag!=Time[0]))
            {  
               Alert ("Chimp and MA of Chimp crossinng LONG ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" Chimp and MA Crossing LONG "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
            }
         }
      }
      else
      {  signal="None";
      }
   }


   for(i=600; i>=0; i--) 
   {  if ((ExtMapBuffer2[i+1]>ExtMapBuffer1[i+1]) && (ExtMapBuffer2[i+2]<ExtMapBuffer1[i+2])) 
      {  if (Draw.Arrows.On.Chart)
         {  ObjectCreate ("ChimpShort  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],High[i+1]+20*Point);
            ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,242);
            ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,3);
            ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,PeachPuff);
         }
      }
      else 
      {  if ((ExtMapBuffer2[i+1]<ExtMapBuffer1[i+1]) && (ExtMapBuffer2[i+2]>ExtMapBuffer1[i+2])) 
         {  if (Draw.Arrows.On.Chart)
            {  ObjectCreate ("ChimpLong  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],Low[i+1]-5*Point);
               ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,241);
               ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,3);
               ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,LightGreen);
            }
         }
      }
   }
   
   string short_name=("Chimp / EMA"); 
   IndicatorShortName(short_name);


//----
   return(0);
  }
//+------------------------------------------------------------------+